蓝桥杯算法题:小数第n位

问题描述

  我们知道,整数做除法时,有时得到有限小数,有时得到无限循环小数。

  如果我们把有限小数的末尾加上无限多个0,它们就有了统一的形式。

  本题的任务是:在上面的约定下,求整数除法小数点后的第n位开始的3位数。

输入格式

  一行三个整数:a b n,用空格分开。a是被除数,b是除数,n是所求的小数后位置(0<a,b,n<1000000000)

输出格式

  一行3位数字,表示:a除以b,小数后第n位开始的3位数字。

样例输入

1 8 1

样例输出

125

样例输入

1 8 3

样例输出

500

样例输入

282866 999000 6

样例输出

914

思路:我也是看了网友的题解才明白的

先举个例子,比如说1/8,首先它的第一位小数1,因为10/8=1......2(因为1不够,要借位,右边的1是商,2是余数),同理取2再进一步除, 20/8=2......4,因此2就是第二位小数,依次类推可得1/8的小数为0.125。那也就是说我知道对于一个数,我知道了1~n-1位的数,那以后的每位都可以通过除和取余来实现。

那如何知道1~n-1位的数呢,可以用快速幂实现,不过还是太大了,得用取模优化,为什么取模没影响呢,因为对于小数来说,整数部分取了模也没有关系的,比如说10/8=1.25,2/8=0.25,只要对除数取模一样,那么小数部分也一样

复制代码
#include<bits/stdc++.h>
using namespace std;
#define ll long long
ll quick_m(int a,int b,int p){
  ll res=1;
  while(b){
    if(b%2)res=res*a%p;
    b/=2;
    a=a*a%p;
  }
  return res;
}
int main(){
  int a,b,n;
  cin>>a>>b>>n;
  a*=quick_m(10,n-1,b);//把n-1位之前的数都变成整数,因为n太大,所以要用快速幂和取模
  a%=b;//为什么这里要取模,比如说1 8 2,上面的式子得到的a是10,若直接用在下边的循环,会出现错误,要保证a<b应用在下边才是小数的结果
  for(int i=0;i<3;i++){//把n,n+1,n+2的结果算出来
    a*=10;
    cout<<a/b;
    a%=b;
  }
  return 0;
}
相关推荐
anew___9 分钟前
《从零手写操作系统 (30):环境变量与进程上下文——export/unset与继承语义》
java·开发语言·网络·jvm·算法
垆边人似月.20 分钟前
城市连通性(200分 / 并查集)
数据结构·算法·图论
我命由我1234521 分钟前
Photoshop - Photoshop 使用简单的选择工具
学习·职场和发展·产品运营·求职招聘·职场发展·学习方法·photoshop
Gust of wind35 分钟前
串与KMP模式匹配:存储结构、基本操作、next数组手算
c语言·数据结构·后端·算法
我命由我1234538 分钟前
Photoshop - Photoshop 使用工具
学习·职场和发展·产品运营·求职招聘·职场发展·产品经理·学习方法
Navigator_Z41 分钟前
LeetCode //C - 1283. Find the Smallest Divisor Given a Threshold
c语言·算法·leetcode
cc5725026531 小时前
2027 秋招|大数据 / 统计类专业运营管培群面,数据思维落地方法
面试·职场和发展
啦啦啦啦啦zzzz1 小时前
一致性哈希
服务器·算法·哈希算法·c++20·分布式存储
垆边人似月.1 小时前
嵌入式传感器寄存器数据解析
算法
Tingmanyi2 小时前
YOLOv13改进策略【卷积层篇】| RFAConv 感受野注意力卷积,每个位置都值得被单独加权
深度学习·算法·yolo·目标检测·计算机视觉